%undefine _package_note_flags
# TESTING NOTE: We cannot run the tests, because they requires ppx_jane.
# We do not yet have that package in Fedora.  Even if we did, it requires this
# package to build, so we would introduce a circular dependency.

%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

# Break a circular dependency on ocaml-odoc
%bcond_with doc

%global upname  ppx_expect

Name:           ocaml-%{upname}
Epoch:          1
Version:        0.15.0
Release:        %mkrel 4
Summary:        Framework for writing tests in OCaml
Group:          Development/OCaml

License:        MIT
URL:            https://github.com/janestreet/ppx_expect
Source0:        %{url}/archive/v%{version}/%{upname}-%{version}.tar.gz

BuildRequires:  ocaml >= 4.08.0
BuildRequires:  ocaml-base-devel >= 0.15
BuildRequires:  ocaml-dune >= 2.0.0
BuildRequires:  ocaml-ppx_here-devel >= 0.15
BuildRequires:  ocaml-ppx_inline_test-devel >= 0.15
BuildRequires:  ocaml-ppxlib-devel >= 0.23.0
BuildRequires:  ocaml-re-devel >= 1.8.0
BuildRequires:  ocaml-stdio-devel >= 0.15

%if %{with doc}
BuildRequires:  ocaml-odoc
%endif

%description
Ppx_expect is a framework for writing tests in OCaml, similar to Cram
(https://bitheap.org/cram/).  Ppx_expect mimics the existing inline
tests framework with the `let%%expect_test` construct.  The body of an
expect-test can contain output-generating code, interleaved with
`%%expect` extension expressions to denote the expected output.

When run, these tests will pass iff the output matches what was
expected.  If a test fails, a corrected file with the suffix
".corrected" will be produced with the actual output, and the
`inline_tests_runner` will output a diff.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{epoch}:%{version}-%{release}
Requires:       ocaml-base-devel%{?_isa}
Requires:       ocaml-ppx_here-devel%{?_isa}
Requires:       ocaml-ppx_inline_test-devel%{?_isa}
Requires:       ocaml-ppxlib-devel%{?_isa}
Requires:       ocaml-re-devel%{?_isa}
Requires:       ocaml-stdio-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%prep
%autosetup -n %{upname}-%{version}

%build
dune build %{?_smp_mflags} --verbose --release
%if %{with doc}
dune build %{?_smp_mflags} @doc
%endif

%install
dune install --destdir=%{buildroot}

%if %{with doc}
# We do not want the dune markers
find _build/default/_doc/_html -name .dune-keep -delete
%endif

# We do not want the ml files
find %{buildroot}%{_libdir}/ocaml -name \*.ml -delete

# We install the documentation with the doc macro
rm -fr %{buildroot}%{_prefix}/doc

%files
%doc CHANGES.md README.org
%license LICENSE.md
%dir %{_libdir}/ocaml/%{upname}/
%dir %{_libdir}/ocaml/%{upname}/collector/
%dir %{_libdir}/ocaml/%{upname}/common/
%dir %{_libdir}/ocaml/%{upname}/config/
%dir %{_libdir}/ocaml/%{upname}/config_types/
%dir %{_libdir}/ocaml/%{upname}/evaluator/
%dir %{_libdir}/ocaml/%{upname}/matcher/
%dir %{_libdir}/ocaml/%{upname}/payload/
%{_libdir}/ocaml/%{upname}/META
%{_libdir}/ocaml/%{upname}/ppx.exe
%{_libdir}/ocaml/%{upname}/*/*.js
%{_libdir}/ocaml/%{upname}/{,*/}*.cma
%{_libdir}/ocaml/%{upname}/{,*/}*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{upname}/{,*/}*.cmxs
%endif
%{_libdir}/ocaml/stublibs/dllexpect_test_collector_stubs.so

%files devel
%if %{with doc}
%doc _build/default/_doc/_html/*
%endif
%{_libdir}/ocaml/%{upname}/dune-package
%{_libdir}/ocaml/%{upname}/opam
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{upname}/{,*/}*.a
%{_libdir}/ocaml/%{upname}/{,*/}*.cmx
%{_libdir}/ocaml/%{upname}/{,*/}*.cmxa
%endif
%{_libdir}/ocaml/%{upname}/{,*/}*.cmt
%{_libdir}/ocaml/%{upname}/{,*/}*.cmti
%{_libdir}/ocaml/%{upname}/{,*/}*.mli



%changelog
* Wed Dec 14 2022 pterjan <pterjan> 1:0.15.0-4.mga9
+ Revision: 1922138
- Rebuild for new ppxlib

* Sun Oct 09 2022 pterjan <pterjan> 1:0.15.0-3.mga9
+ Revision: 1895905
- Rebuild for new ocaml-base

* Fri May 20 2022 pterjan <pterjan> 1:0.15.0-2.mga9
+ Revision: 1859490
- Add epoch as we had the package with an epoch in the past

* Fri May 20 2022 pterjan <pterjan> 0.15.0-1.mga9
+ Revision: 1859488
- imported package ocaml-ppx_expect

